# enkhe retina post

- [ ] name post
  - Building cross-platform mobile app with Tauri+Preact+Vite
- [X] intro
  - I joined Norcivilian Labs as a frontend engineer in Fall and took up building the mobile application for [Retina.AI](screenretina.com). The client previously had an alpha release for Android in Kotlin, and a prototype for iOS in Swift, and we offered to build one app that would rule them all, using the awesome [Tauri](tauri.app). The Tauri framework is not stable yet, but we at NL love to live at the cutting-edge, and made the move from Electron to Tauri last year. The separation of concernce in Tauri is pretty good, so I knew I could write frontend, and let the Rust folks do finish the job later.
- [X] why we use Preact
  - Tauri docs recommended vite+preact, and we loved Preact documentation - their info about hyperscript.
- [X] router
  - We had a design in PenPot [screenshots here] which client gave us from the previous android prototype. So I set up the router according to user path - we use preact-router and it's very lovely and simple.
- [X] login, profile, registration
  - Our design had a login screen and a registration screen. I implemented HTML forms for both screens. The profile screen was a list of labels and user information, I made sure to use semantic elements on each screen to comply with HTML standards.
- [X] refactor project structure
  - Like in other NL projects, I stored each JSX component in a separate folder, named in snake_case.
- [X] fetch for login and signup, fix field names
  - Client sent us REST [API](https://retina.docs.norcivilianlabs.org/api.html) with request headers for each endpoint. I only used REST once in the past, so I studied again what REST is and how it works. In JavaScript we use Fetch API to talk with REST, and the client uses POST requests for everything so I wrote code for fetching.
- [X] fetch for profile
  - The fetch request for the profile screen had a dozen fields, and we showed fields in useState variables.
- [X] state management for token
  - I created a state variable for the token at the root application component level (app.jsx) using useState. Then I passed the setToken function to the Login screen component. Login screen received a token and passed its value through state to other components (Menu, Profile, Detection, Signup) that use the token. 
- [X] options for countries and professions
  - registration screen needed a list of possible professions and countries. Ie used a JavaScript array with a list of possible values according to the documentation https://retina.docs.norcivilianlabs.org/api.html#countries-list. I used the map() method to generate option tags for each contry from the array and display them as a list of options in input fields on the registration screen.
- [X] outro
  - This was my first large independent project and I loved it. I learned about REST, Fetch API, hyperscript,  I got used to writing daily reports in our public Zulip and they really helped while writing this article. [Sign up](https://norcivilianlabs.zulipchat.com) to follow our activity!



I joined Norcivilian Labs as a frontend engineer in Fall and took up building the mobile application for [Retina.AI](screenretina.com). The client previously had an alpha release for Android in Kotlin, and a prototype for iOS in Swift, and we offered to build one app that would rule them all, using the awesome [Tauri](tauri.app). The Tauri framework is not stable yet, but we at NL love to live at the cutting-edge, and made the move from Electron to Tauri last year. The separation of concernce in Tauri is pretty good, so I knew I could write frontend, and let the Rust folks do finish the job later. Tauri docs recommended vite+preact, and we loved Preact documentation - their info about hyperscript.We had a design in PenPot [screenshots here] which client gave us from the previous android prototype. So I set up the router according to user path - we use preact-router and it's very lovely and simple.We had a design in PenPot [screenshots here] which client gave us from the previous android prototype. So I set up the router according to user path - we use preact-router and it's very lovely and simple.Our design had a login screen and a registration screen. I implemented HTML forms for both screens. The profile screen was a list of labels and user information, I made sure to use semantic elements on each screen to comply with HTML standards.Like in other NL projects, I stored each JSX component in a separate folder, named in snake_case.Client sent us REST [API](https://retina.docs.norcivilianlabs.org/api.html) with request headers for each endpoint. I only used REST once in the past, so I studied again what REST is and how it works. In JavaScript we use Fetch API to talk with REST, and the client uses POST requests for everything so I wrote code for fetching.The fetch request for the profile screen had a dozen fields, and we showed fields in useState variables.I created a state variable for the token at the root application component level (app.jsx) using useState. Then I passed the setToken function to the Login screen component. Login screen received a token and passed its value through state to other components (Menu, Profile, Detection, Signup) that use the token. registration screen needed a list of possible professions and countries. Ie used a JavaScript array with a list of possible values according to the documentation https://retina.docs.norcivilianlabs.org/api.html#countries-list. I used the map() method to generate option tags for each contry from the array and display them as a list of options in input fields on the registration screen.This was my first large independent project and I loved it. I learned about REST, Fetch API, hyperscript,  I got used to writing daily reports in our public Zulip and they really helped while writing this article. [Sign up](https://norcivilianlabs.zulipchat.com) to follow our activity!
